function WWW=epoch_chyb_sit_341(Vzorky,Test,poc_w12,poc_w23,Line,gama,Epoch)

% 25.2.2012, 2.4.2012
% epoch_chyb_sit_341
% specialne pro sit_341

% vstup:
% Vzorky = soubor r1 radkovych trenovacich vektoru, size(Vzorky)=[r1 4], 
% ... tozn. vektor X a target T k tomu
% Epoch = prirozene cislo, kolikrat ucit sit na danem souboru?
% Line = nabyva hodnot {'of', 'on'} podle typu treninku
% Test = soubor r2 radkovych testovacich vektoru, size(Test)=[r2 4]
% poc_w12 = pocatecni vahy size(poc_w12)=[4 4]
% poc_w23 = pocatecni vahy size(poc_w23)=[5 1]
% gama = kladne cislo, ucebni konstanta

% vystup:
% 3 grafy v jednom: 
% vyvoj relativni chyby, senzitivity a specificity v zavislosti na 
% poctu epoch (a samozrejme na dalsich vecech, ktere do grafu neuvadim)
% dalsi graf - zobrazuje vyvoj vah v prubehu epoch

% priprava ucebnich dat:
[r1 s1]=size(Vzorky);
[r2 s2]=size(Test);
if (s1~=4)||(s2~=4)
    error('Spravny pocet sloupcu v prvni a druhe promenne je 4.')
end
X=Vzorky(:,1:3);    % 3d vstupy do site sit_341, slouzi k uceni
T=Vzorky(:,4);      % to, kam ktery vstup X radim
Xtest=Test(:,1:3);  % 3d vstupy do site sit_341, slouzi k testovani
Ttest=Test(:,4);    % to, kam ktery vstup Xtest radim
w12=poc_w12; 
w23=poc_w23;

m=sum((T-1)&(T-1)); % pocet tech T, pro nez je T=-1
p=sum((T+1)&(T+1)); % pocet tech T, pro nez je T=1
% plati: m + p = r1

% sklad epochami probihajicich vah
WWW=zeros(21,Epoch);

% tady tu sit naucim pomoci backpropagation
if Line=='on'
    for i=1:1:Epoch
        % ---- v --- nahodny vyber jednoho vzorku --- v --- 
        JD=1-2*round(rand(1)); % z Jednotek nebo Dvojic ?? (spravedlive)
        if JD==-1 % Jednotky
            j=round(m*rand(1));
            if j==0 j=1; end
            ind=1; pocetJ=0;
            while pocetJ<j
                if T(ind)==-1
                    pocetJ=pocetJ+1;
                end
                ind=ind+1;
            end
            k=ind-1; % pozice j-te hodnoty -1 ve vektoru T
        elseif JD==1 % Dvojice
            j=round(p*rand(1));
            if j==0 j=1; end
            ind=1; pocetJ=0;
            while pocetJ<j
                if T(ind)==1
                    pocetJ=pocetJ+1;
                end
                ind=ind+1;
            end
            k=ind-1; % pozice j-te hodnoty 1 ve vektoru T
        end
        % ---- ^ --- nahodny vyber jednoho vzorku --- ^ --- 
        % ---- v --- on-line trenink --- v --- 
        [w12,w23]=uc_sit_341_bp_on(w12,w23,X(k,:),T(k),gama);  % uc_sit_341_bp_on
        % prubezne vysledky:
        WWW(1:4,i)=w12(:,1); WWW(5:8,i)=w12(:,2); WWW(9:12,i)=w12(:,3); 
        WWW(13:16,i)=w12(:,4); WWW(17:21,i)=w23(:,1); 
        % ---- ^ --- on-line trenink --- ^ --- 
    end
elseif Line=='of' % tady pisu 'of' misto 'off', aby to fungovalo
    for i=1:1:Epoch
        [w12,w23]=uc_sit_341_bp_off(w12,w23,X,T,gama);  % uc_sit_341_bp_off
        % prubezne vysledky:
        WWW(1:4,i)=w12(:,1); WWW(5:8,i)=w12(:,2); WWW(9:12,i)=w12(:,3); 
        WWW(13:16,i)=w12(:,4); WWW(17:21,i)=w23(:,1);
    end
else
    error('Paty argument teto funkce je spatne zadany.')
end

% tady hotovou sit otestuju 
dografu=zeros(3,Epoch);
for i=1:1:Epoch
    % sit_341 - externi funkce:
    Ytest=sit_341(Xtest,[WWW(1:4,i),WWW(5:8,i),WWW(9:12,i),WWW(13:16,i)],WWW(17:21,i)); 
    rch=reler(Ytest,Ttest); % reler - externi funkce
    [senz spec]=senzspec(Ytest,Ttest); % senzspec - externi funkce
    dografu(1,i)=rch;
    dografu(2,i)=senz;
    dografu(3,i)=spec;
end

% tady nakreslim grafy chyb -----------------------------------
figure;
axis equal
plot(1:1:Epoch,dografu(1,:),'r'); % relativni chyba
hold on
plot(1:1:Epoch,dografu(2,:),'g'); % poc. spravne klas. (-1)
hold on
plot(1:1:Epoch,dografu(3,:),'b'); % poc. spravne klas. (+1)
hold off
% tady nakreslim grafy chyb -----------------------------------

% % vysledky (misto WWW):
% w12=[WWW(1:4,Epoch),WWW(5:8,Epoch),WWW(9:12,Epoch),WWW(13:16,Epoch)];
% w23=WWW(17:21,Epoch);

% % tady nakreslim grafy vah ------------------------------------
% figure;
% axis equal
% plot(1:1:Epoch,WWW(1:4,:),'c'); % vahy w12(:,1)
% hold on
% plot(1:1:Epoch,WWW(5:8,:),'m'); % vahy w12(:,2)
% hold on
% plot(1:1:Epoch,WWW(9:12,:),'y'); % vahy w12(:,3)
% hold on
% plot(1:1:Epoch,WWW(13:16,:),'k'); % vahy w12(:,4)
% hold on
% plot(1:1:Epoch,WWW(17:21,:),'r'); % vahy w23(:,1)
% hold off
% % tady nakreslim grafy vah ------------------------------------

