function [w,R,J,D]=perc_uc_01042012(ucvz,testvz,w0,chyba,iteraci)
% algoritmicke uceni perceptronu - neuronu s aktivacni funkci signum
% 1.4.2012, 3.4.2012

% prikazy do cmd window: 
% open train3ch2tr.mat
% ucvz=ans.train3ch2tr;
% testvz=ans.test3ch2tr;
% w0=rand(1,4)-2; 
% chyba=0.1;
% iteraci=5000;
% [w,R,J,D]=perc_uc_01042012(ucvz,testvz,w0,chyba,iteraci)

% vstupy: 
% ucvz, size(ucvz)=[r1 4]
% testvz, size(testvz)=[r2 4]
% vahy w0, size(w0)=[1 4]
% chyba, z intervalu (0,1) 
% iteraci, kolik vzorku bude siti predlozeno % 5000;

% priprava trenovacich a testovacich vzorku:
xka=ucvz(:,1:3); % vzorky trenovaci
tv=testvz(:,1:3); % vzorky testovaci
tt=testvz(:,4); % targety testovacich vzorku
[xr xs]=size(xka); % zjisti pocet [radku sloupcu]
[tr ts]=size(tv); % zjisti pocet [radku sloupcu]

w=w0; jine=1; i=1;
while (jine>=chyba)||(i<=iteraci)
    j=xr-round((xr-1)*rand(1)); % pro nahodny vzorek 
    vstup=[xka(j,:),1];
    target=ucvz(j,4);
    if (target==1)&&(w*vstup'>0)
        i=i+1;
    elseif (target==1)&&(w*vstup'<=0)
        w=w+vstup;
        i=i+1;
    elseif (target==-1)&&(w*vstup'<0)
        i=i+1;
    elseif (target==-1)&&(w*vstup'>=0)
        w=w-vstup;
        i=i+1;
    end
    % ted testujeme ziskane vahy
    ty=sign(w*[tv,ones(tr,1)]');
    jine=reler(ty',tt); %sum(abs(tt-ty'))/2200;
end

R = jine; % relativni chyba
J = senzJ(ty',tt); % podil Jednotek spravne klasifikovanych
D = senzD(ty',tt); % podil Dvojic spravne klasifikovanych

% Jednotek spravne:
function a=senzJ(Y,T)
T=round(T);
Y(Y<0)=-1;
Y(Y>=0)=1;
poc_jedn=sum(T==-1);
OK_jedn=sum((T==-1)&(Y==-1));
a=OK_jedn/poc_jedn;
end

% Dvojic spravne:
function b=senzD(Y,T)
T=round(T);
Y(Y<0)=-1;
Y(Y>=0)=1;
poc_dvoj=sum(T==1);
OK_dvoj=sum((T==1)&(Y==1));
b=OK_dvoj/poc_dvoj;
end

end % function



% pro ziskane vahy w:
% w = [-4.7316 -7.4183 13.191 2.1813]; 
% je dosazena chyba 0.031818 (nejlepsi vysledek asi 30 nahodnych pokusu)
% z toho spravne klasifikovanych Jednotek  0.988
% z toho spravne klasifikovanych Dvojic    0.77

% proto neuronova sit muze mit tento predpis: 
% w = [-4.7316 -7.4183 13.191 2.1813]; 
% y = sign([x,1]*w'); % y=NN(x)
