function [w12,w23]=uc_sit_341_bp_off(poc_w12,poc_w23,x,t,gama)

% 25.2.2012
% uc_sit_341_bp_off - to je: uc sit_341 pomoci algoritmu backpropagation
% a off-line treningem

% w12 = vahy synapsi po uceni
% w23 = vahy synapsi po uceni
% poc_w12 = vstupni, pocatecni vahy mezi 1. a 2. vrstvu
% poc_w23 = vstupni, pocatecni vahy mezi 2. a 3. vrstvu
% x = soubor vstupnich (radkovych) vektoru
% t = soubor cilu (Targets)
% gama = ucebni konstanta - musi byt kladna - jak ji zvolit?

% do cmd wind:
% open train3ch2tr.mat 
% train=ans.train3ch2tr; test=ans.test3ch2tr; 
% x=train(:,1:3); t=train(:,4); 
% poc_w12=1-2*rand(4,4); poc_w23=1-2*rand(5,1);
% gama=0.01;

[r s]=size(x); 
w12=poc_w12;
w23=poc_w23;
gradienty=zeros(21,r); % celkem 21 synapsi (4*4+5*1)
% tomuto se rika off-line training
for i=1:1:r
    y=sit_341(x(i,:),w12,w23); % sit_341 je externi funkce
    % sumy jdouci do neuronuu ve 2. vrstve:
    s12=[x(i,:),1]*w12; % size(s12)=[1 4]
    % suma jdouci do neuronu ve 3. vrstve:
    s23=[tanh(s12),1]*w23; % size(s23)=[1 1]
    out1=[x(i,:),1]; % "vystupy" 1. vrsty (= vstupy do site)
    out2=[tanh(s12),1]; % vystupy 2. vrsty
    out3=y; % vystup 3. vrsty (= vystup ze site)
    delta3=(out3-t(i))*(1-out3^2);
    delta2=(delta3*w23(1:5)*(1-out2(1:5).^2).*eye(5))*ones(5,1);
    % delta1 neni, size(delta2)=[5 1], size(delta3)=[1 1]
    gradienty(1:4,i)=delta2(1)*out1'; % derivace E podle vah z w12(:,1)
    gradienty(5:8,i)=delta2(2)*out1'; % derivace E podle vah z w12(:,2)
    gradienty(9:12,i)=delta2(3)*out1'; % derivace E podle vah z w12(:,3)
    gradienty(13:16,i)=delta2(4)*out1'; % derivace E podle vah z w12(:,4)
    gradienty(17:21,i)=delta3(1)*out2'; % derivace E podle vah z w23(:,1)
end
gradient=(sum(gradienty'))'; % sum totiz scita prvky ve sloupcich
% vse udelano najednou, nikoliv prubezne
w12(:,1)=w12(:,1)-gama*gradient(1:4,1);
w12(:,2)=w12(:,2)-gama*gradient(5:8,1);
w12(:,3)=w12(:,3)-gama*gradient(9:12,1);
w12(:,4)=w12(:,4)-gama*gradient(13:16,1);
w23(:,1)=w23(:,1)-gama*gradient(17:21,1);
